$startpage='http://yourdomain.ru/';#all pages from this domain will be found if URL includes $required and not includes $denied substrings
$required='http';#required substring of full URL for download this page
$denied='substring of URL which denies to download this page';
$external='yes';#check external links with download URLs? (any other value means 'no')
$delay=3; #seconds between queries;
$timeout=100;#max seconds of waiting for reply
$maxpages=10000;


$toloadlevels=100;
$pagenow=0;

use LWP::UserAgent;
use HTTP::Request;
use URI::URL;
use HTTP::Headers;

$ua = new LWP::UserAgent;
$ua->agent('Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)');
$ua->max_size(100000);
$ua->timeout($timeout);

%pages=();
@data=();
@levels=();


sub getdomain
{
my $paga=$_[0];
$paga=~s#^http://##ig;
if ($paga=~m#^(.*?)[?:/]#i) {$paga=$1};
return "http://".$paga;
}

sub full
{
my $parent=$_[0];
my $child=$_[1];
my $proto;
my $domains;
my $dir;
my $file;

if ($child=~m#\.(xls|doc|rtf|txt|gif|jpg|jpeg|mpg|mpeg|mp3|tiff|avi|wov|exe|zip|rar|gz|tar|bz2|bz|tgz|lha|lzh|arj|mov|wav|au|qt|mpe|midi|ra|ram|rm)#i) {return ''};

if ($child=~m#http://#i) {return $child};
if ($child=~m#^/#i)
    {
    if ($parent=~s|(https?://)?(([0-9a-zA-Z_-]+\.)+[0-9a-zA-Z_-]{2,4})((/[0-9a-zA-Z_-]+?)*?)/?([^/]*?[?#.][^/]*)?$|$proto=$1; $domain=$2; $dirs=$4; $file=$6|ige )
        {
        if ($proto eq '') {$proto='http://';};
        $child=~s/#.*$//;
        return $proto.$domain.$child;
        };
    }
else    {
$child=~s#\.\./#/#ig;

if ($parent=~s|(https?://)?(([0-9a-zA-Z_-]+\.)+[0-9a-zA-Z_-]{2,4})((/[0-9a-zA-Z_-]+?)*?)/?([^/]*?[?#.][^/]*)?$|$proto=$1; $domain=$2; $dirs=$4; $file=$6|ige )
{
while ($child=~m#^/#)
    { if ($dirs=~m#/[0-9a-zA-Z_-]+$#)
            {
            $child=~s#^/##;
            $dirs=~s#/[0-9a-zA-Z_-]+$##;
            }
      else  {
            print "incorrect link out of dirs\n";
            $child=~s#^/##;
            };
    };
}
else {print "can't understand parent url..\n";};

$child="/".$child;
$child=~s#^//#/#;
if ($proto eq '') {$proto='http://';};

$child=~s/#.*$//;

return $proto.$domain.$dirs.$child;
    };
}



sub deletetags
{
my $txt=$_[0];
$txt=~s#<head>.+</head># #is;
$txt=~s#<script[^>]+?>.+?</script># #igs;
$txt=~s#<.+?># #igs;
$txt=~s#</.+?># #igs;
$txt=~s# +# #ig;
return $txt;
}

sub check
{
my $urlo=$_[0];
my $from=$_[1];

if ($external eq 'yes')
	{
	$hdrs = new HTTP::Headers(Accept => 'text/html',ACCEPT_LANGUAGE => 'ru');
	$url = new URI::URL($urlo);
	$req = new HTTP::Request(GET, $url, $hdrs);
	$req->referer($currentpage);
	
	print "delay=$delay...\n";
	sleep($delay);
	$resp = $ua->request($req);
	
	if ($resp->is_success)
	    {
	    $result=$resp->content;
		$title='empty';
		$result=~s#<title>([^\n]+).*?</title>#$title=$1;#ies;
	    open (GI, ">>external_found_pages.html");
	    print GI "<p>$urlo: <a href=\"$urlo\">$title</a>\n";
	    close GI;
		$pages{$urlo}="ok";
		}
	else
		{
		$msg=$resp->message;
		print "at $urlo I failed with $msg\n";
	    open (GI, ">>external_rejected_pages.txt");
	    print GI "$urlo\t$msg\tlinked from $from\n";
	    close GI;
		$pages{$urlo}="failed with $msg";
		};
	}
else
	{
	open (GG, ">>external_links_not_checked.txt");
	print GG $urlo."\n";
	close GG;
	$pages{$urlo}='written';
	};

return 0;
};

sub peerinto
{
my $urlo=$_[0];
my $lev=$_[1];
my @links;
my @mails;
my @domains;
my $baseurl;
my $refresh;
my $title;
my $keywords;
my $description;
my $text;
my $filename;
my $rcopy;
my $del;
my $i;

$lev-=1;

if ($pagenow>$maxpages) { print "Maximum pages ($pagenow) reached!\n"; return 0;}
 else
 {

$hdrs = new HTTP::Headers(Accept => 'text/html',ACCEPT_LANGUAGE => 'ru');
$url = new URI::URL($urlo);
$req = new HTTP::Request(GET, $url, $hdrs);
$req->referer($currentpage);

print "delay=$delay...\n";
sleep($delay);
$resp = $ua->request($req);

if ($resp->is_success)
    {
    $currentpage=$urlo;
    $result=$resp->content;
    $rcopy=$result;
	
	$title='';
	$rcopy=~s#<title>([^\n]+).*?</title>#$title=$1;#ies;
		$h1='';
		$rcopy=~s#^.*<h\d>([^<]+).*?</h\d>#$h1=$1; $hlp='';#ie;
		$rcopy=~s#</h\d>#:#i;
		$rcopy=~s#\.+#.#i;
		$rcopy=deletetags($rcopy);
		$rcopy=~s#\&[a-zA-Z]+\;# #ig;
		$rcopy=~s#&[a-zA-Z]\;|<\S+|\S+># #gs;
		$rcopy=~s#<|># #gs;
		$rcopy=~s#(\d+[ -]){2,}# #ig;
		$rcopy=~s#\s+# #ig;
		$rcopy=~s#([^ ] ){3,}# #ig;
		$rcopy=~s#\s+# #gs;
		$rcopy=~s#\s+(,|\.|\;|\:|\?|\!)\s#$1 #ig;
		$rcopy=~s#(([^\.]+\.){1,3})#$snippet='<br>'.$1;#ise;
	if (($alltitles{$title} ne '')&&($h1 ne ''))
		{
		$title.=' - '.$h1;
		};
	$alltitles{$title}=1;
    open (GI, ">>sitemap_snippets.html");
    print GI "<p><a href=\"$urlo\">$title</a>$snippet\n";
    close GI;

    open (GI, ">>sitemap_nosnippets.html");
    print GI "<p><a href=\"$urlo\">$title</a>\n";
    close GI;

    open (GI, ">>sitemap_short.html");
	$numpgg++;
    print GI "<a href=\"$urlo\">$numpgg</a>, \n";
    close GI;

    open (GG, ">>inner_found_pages.txt");
    print GG $urlo."\n";
    close GG;

    $result=~s/\s+/ /g;
    $result=~s/['"] ?\+ ?['"]//g;

    print "\nI am at the $urlo\nlevel=$lev\n";
#    <>;

    $curdomain=getdomain($urlo);
    $baseurl=$urlo;
    $result=~s/<base .*?(url|href) ?= ?(["']) ?(.+?) ?\1.*?>/$baseurl=$2; push (@links, $2)/ige;

    @links=();
    $result=~s#(location|href)=(["']?)([^"'<> 	]+)(["']?)#push (@links, $3);#ige;

    @domains=();
    for ($i=0;$i<@links;$i++)
    {
    #print "$i'st link is $links[$i]\n"; $num++;
    $q=$links[$i];
    print "found link $q, corrected as ";
    print $links[$i]=full($baseurl,$links[$i]);
    push(@domains, getdomain($links[$i]) );
    print "\n";
    };

    for ($i=0;$i<@mails;$i++)
    {
    $q=$mails[$i];
    print "found mailto($q)";
    print "\n";
    };

$mailss=join(', ', @mails);
$linkss=join(', ', @links);

    print "browse links-\n";
#    <>;


    for ($i=0;$i<@links;$i++)
    {
#    $num+=peerinto($links[$i],$lev);

if ( ($links[$i]=~m#$required#i) && !($links[$i]=~m#$denied#i)  )
{
    if ($pages{$links[$i]} eq '')
        {
	$pages{$links[$i]}='to check';
        if (!($curdomain=~m#$domains[$i]#i)) 
		{
		print check($links[$i],$urlo);
		}
        else    {$pagenow++; $num+=peerinto($links[$i],$lev) };
        }
    else {print $links[$i]." link is already found..\n"};
    };
};
    $num+=$matchall;

   
    return $num;

#    ********************************************
    }
else
{$msg=$resp->message;
open (GB, '>>inner_rejected_pages.txt');
print GB "$urlo\t$msg\tlinked from $currentpage\n";
print "at $urlo I failed with $msg\n";
close GB;
$pages{$urlo}="failed with $msg";
return 0;};
 };
};






$currentpage=$startpage;

print peerinto($startpage, $toloadlevels);

open(F, "<onemore.txt");
until(eof(F)) 
{
$a=<F>;
chomp $a;
push(@onemore,$a);
};
close F;

for ($i=0; $i<@onemore; $i++)
{
$required=$onemore[$i];
print peerinto($onemore[$i], 100);
};

print "\a";
__END__;